package com.tzld.longarticle.recommend.server.common.enums;

import lombok.Getter;

import java.util.Objects;

@Getter
public enum RankStrategyEnum {
    ArticleRankV2("ArticleRankV2", "ArticleRankV2", "rankV2Strategy"),
    ArticleRankV3("ArticleRankV3", "ArticleRankV3", "rankV3Strategy"),
    ArticleRankV4("ArticleRankV4", "ArticleRankV4", "rankV4Strategy"),
    ArticleRankV5("ArticleRankV5", "ArticleRankV5", "rankV5Strategy"),
    ArticleRankV6("ArticleRankV6", "ArticleRankV6", "rankV6Strategy"),
    ArticleRankV7("ArticleRankV7", "ArticleRankV7", "rankV7Strategy"),
    ArticleRankV8("ArticleRankV8", "ArticleRankV8", "rankV8Strategy"),
    ArticleRankV9("ArticleRankV9", "ArticleRankV9", "rankV9Strategy"),
    ArticleRankV10("ArticleRankV10", "ArticleRankV10", "rankV10Strategy"),
    ArticleRankV11("ArticleRankV11", "ArticleRankV11", "rankV9Strategy"),

    default_strategy("ArticleRankV1", "默认策略", "defaultRankStrategy"),
    ;

    private final String strategy;
    private final String description;
    private final String taskExecutorName;

    RankStrategyEnum(String strategy, String description, String taskExecutorName) {
        this.strategy = strategy;
        this.description = description;
        this.taskExecutorName = taskExecutorName;
    }

    public static RankStrategyEnum from(String strategy) {
        for (RankStrategyEnum statusEnum : RankStrategyEnum.values()) {
            if (Objects.equals(statusEnum.strategy, strategy)) {
                return statusEnum;
            }
        }
        return default_strategy;
    }
}
